(function () {

    var urlList = [], tabId, op_type, sleep_time, sleep_per_row, current_row;
	current_row = 0;
	
	var xhr = new XMLHttpRequest();

	function getData(urls, i) {
		current_row++;

		if ( typeof urls[i] == 'undefined' ) return;
		if ( typeof urls[i]['page_url'] == 'undefined' ) return;
		
		var request_type = 'GET';
		var request_data_type = 'text';
		var request_headers = {};
		if ( typeof urls[i]['request_type'] != 'undefined' ) request_type = urls[i]['request_type'];
		if ( typeof urls[i]['request_data_type'] != 'undefined' ) request_data_type = urls[i]['request_data_type'];
		if ( typeof urls[i]['request_post_data'] == 'undefined' ) urls[i]['request_post_data'] = '';
		if ( typeof urls[i]['request_headers'] != 'undefined' ) request_headers = urls[i]['request_headers'];
		
		// cookies
		if ( typeof urls[i]['cookies_remove'] != 'undefined' && Array.isArray(urls[i]['cookies_remove'])) {
			urls[i]['cookies_remove'].forEach(function(item, i, arr) {
						chrome.cookies.remove({ url: item['url'], name: item['name']});
					}
				)
		}
		if ( typeof urls[i]['cookies_set'] != 'undefined' && Array.isArray(urls[i]['cookies_set'])) {
			urls[i]['cookies_set'].forEach(function(item, i, arr) {
						chrome.cookies.set({ url: item['url'], name: item['name'], value: item['value']});
					}
				)
		}

		$.ajax({
			type: request_type,
			url: urls[i]['page_url'],
			data: urls[i]['request_post_data'],
			cache: true,
			async: false,
			dataType: 'text',
			timeout: 5000,
			headers: request_headers,
			xhr: function() {
				return xhr;
			},
			success: function (data, textStatus, xhr) {
			
				if (request_data_type=='json') data = btoa(data);
				
				urlList = []
				
				urlList.push({
					status_code: xhr.status,
					responseURL: xhr.responseURL,
					url: urls[i]['page_url'],
					custom_data: urls[i]['custom_data'],
					page_url_type: urls[i]['page_url_type'],
					data_type: request_data_type, 
					data: data, 
					error: ""
				});
				
				// send log to user
				var work_status = urls[i]['custom_data']['search_value'];
				if (typeof urls[i]['custom_data']['found_item'] != 'undefined' && urls[i]['custom_data']['found_item'] != '') work_status = urls[i]['custom_data']['found_item'];
				
				chrome.tabs.sendMessage(tabId, {op_type: op_type, message_type: 'work_log', work_status: work_status}, function () {});

				if ((i + 1) < urls.length) {
					if (op_type=='save_page') {
						chrome.tabs.sendMessage(tabId, {op_type: op_type, message_type: 'get_page', urlList: urlList}, function () {
							urlList = [];
						});
					}
					if (op_type=='save_page_job') {
						chrome.tabs.sendMessage(tabId, {op_type: op_type, message_type: 'save_page_job', urlList: urlList}, function () {
							urlList = [];
						});
					}		

					getData(urls, i + 1);
					
				} else {
					if (op_type=='save_page') {
						chrome.tabs.sendMessage(tabId, {op_type: op_type, message_type: 'get_page', urlList: urlList}, function () {
							urlList = [];
						});
						
						chrome.tabs.sendMessage(tabId, {op_type: 'work_finish', message_type: 'get_page', urlList: []}, function () {
							urlList = [];
						});
					} else { // search_page
						if (op_type=='save_page_job') {
							chrome.tabs.sendMessage(tabId, {op_type: op_type, message_type: 'save_page_job', urlList: urlList}, function () {
								urlList = [];
							});
						} else { // search_page
							chrome.tabs.sendMessage(tabId, {op_type: op_type, message_type: 'get_page', urlList: urlList}, function () {
								urlList = [];
							});						
						}
						
					}
				}
				
			},
			fail: function (xhr, textStatus, errorThrown) {
				console.log("jumper get page error: "+ textStatus + errorThrown);

				// send log to user
				chrome.tabs.sendMessage(tabId, {op_type: op_type, message_type: 'work_log', work_status: "Get page error: "+ textStatus + errorThrown}, function () {});
				
				urlList.push({
					status_code: xhr.status,
					url: urls[i]['page_url'],
					custom_data: urls[i]['custom_data'],
					page_url_type: urls[i]['page_url_type'],
					data_type: request_data_type, 
					data: "error", 
					error: textStatus + errorThrown
				});
					
				if ((i + 1) < urls.length) {
					getData(urls, i + 1);
				} else {
					chrome.tabs.sendMessage(tabId, {op_type:op_type, message_type: 'get_page', urlList: urlList}, function () {
						urlList = [];
					});
				}
			}
		});

    }

    chrome.runtime.onMessage.addListener(function (message, sender, sendResponse) {
		tabId = sender.tab.id;
		op_type = message.config['op_type'];
		sleep_time = message.config['sleep_time'];
		sleep_per_row = message.config['sleep_per_row'];
		
        getData(message.urlList, 0);
		
		return true;
    });
	
	// content policy
	var HEADERS_TO_STRIP_LOWERCASE = [
	  'content-security-policy',
	  'x-frame-options',
	];

	chrome.webRequest.onHeadersReceived.addListener(
	  function(details) {
		return {
		  responseHeaders: details.responseHeaders.filter(function(header) {
			return HEADERS_TO_STRIP_LOWERCASE.indexOf(header.name.toLowerCase()) < 0;
		  })
		};
	  }, {
		urls: ["<all_urls>"]
	  }, ["blocking", "responseHeaders"]);

	
}());
